- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# os_user – Manage OpenStack Identity Users

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Manage OpenStack Identity users. Users can be created, updated or deleted using this module. A user will be updated if name matches an existing user and state is present. The value for name cannot be updated without deleting and re-creating the user.

## Requirements

The below requirements are needed on the host that executes this module.

- openstacksdk
- openstacksdk >= 0.12.0
- python >= 2.7

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
api_timeout integer |  | How long should the socket layer wait before timing out for API calls. If this is omitted, nothing will be passed to the requests library.
auth dictionary |  | Dictionary containing auth information as needed by the cloud's auth plugin strategy. For the default password plugin, this would contain auth_url, username, password, project_name and any information about domains (for example, os_user_domain_name or os_project_domain_name) if the cloud supports them. For other plugins, this param will need to contain whatever parameters that auth plugin requires. This parameter is not needed if a named cloud is provided or OpenStack OS_* environment variables are present.
auth_type string |  | Name of the auth plugin to use. If the cloud uses something other than password authentication, the name of the plugin should be indicated here and the contents of the auth parameter should be updated accordingly.
availability_zone - |  | Ignored. Present for backwards compatibility
ca_cert string |  | A path to a CA Cert bundle that can be used as part of verifying SSL API requests. aliases: cacert
client_cert string |  | A path to a client certificate to use as part of the SSL transaction. aliases: cert
client_key string |  | A path to a client key to use as part of the SSL transaction. aliases: key
cloud raw |  | Named cloud or cloud config to operate against. If cloud is a string, it references a named cloud config as defined in an OpenStack clouds.yaml file. Provides default values for auth and auth_type. This parameter is not needed if auth is provided or if OpenStack OS_* environment variables are present. If cloud is a dict, it contains a complete cloud configuration like would be in a section of clouds.yaml.
default_project - |  | Project name or ID that the user should be associated with by default
description - added in 2.4 |  | Description about the user
domain - |  | Domain to create the user in if the cloud supports domains
email - |  | Email address for the user
enabled boolean | Choices: no yes ← | Is the user enabled
interface string | Choices: admin internal public ← | Endpoint URL type to fetch from the service catalog. aliases: endpoint_type
name - / required |  | Username for the user
password - |  | Password for the user
region_name string |  | Name of the region.
state - | Choices: present ← absent | Should the resource be present or absent.
timeout integer | Default: 180 | How long should ansible wait for the requested resource.
update_password - | Choices: always on_create | `always` will attempt to update password. `on_create` will only set the password for newly created users.
validate_certs boolean | Choices: no ← yes | Whether or not SSL API requests should be verified. Before Ansible 2.3 this defaulted to `yes`. aliases: verify
wait boolean | Choices: no yes ← | Should ansible wait until the requested resource is complete.

## Notes

Note

- The standard OpenStack environment variables, such as `OS_USERNAME` may be used instead of providing explicit values.
- Auth information is driven by openstacksdk, which means that values can come from a yaml config file in /etc/ansible/openstack.yaml, /etc/openstack/clouds.yaml or ~/.config/openstack/clouds.yaml, then from standard environment variables, then finally by explicit parameters in plays. More information can be found at https://docs.openstack.org/openstacksdk/

## Examples

    # Create a user
    - os_user:
        cloud: mycloud
        state: present
        name: demouser
        password: secret
        email: demo@example.com
        domain: default
        default_project: demo

    # Delete a user
    - os_user:
        cloud: mycloud
        state: absent
        name: demouser

    # Create a user but don't update password if user exists
    - os_user:
        cloud: mycloud
        state: present
        name: demouser
        password: secret
        update_password: on_create
        email: demo@example.com
        domain: default
        default_project: demo

    # Create a user without password
    - os_user:
        cloud: mycloud
        state: present
        name: demouser
        email: demo@example.com
        domain: default
        default_project: demo

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
user complex | On success when state is 'present' | Dictionary describing the user.
| default_project_id string |  | User default project ID. Only present with Keystone >= v3. Sample: 4427115787be45f08f0ec22a03bfc735
| domain_id string |  | User domain ID. Only present with Keystone >= v3. Sample: default
| email string |  | User email address Sample: demo@example.com
| id string |  | User ID Sample: f59382db809c43139982ca4189404650
| name string |  | User name Sample: demouser

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- David Shrewsbury (@Shrews)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.